//=============================================================================
// InvBank.
//=============================================================================
//
// InventoryBank, made by Cookies.
//
// If you activate this mutator and give every player the InventoryBank item,
// under inventory. They will be able to save their inventory on your server
// hardisk and load it again from there. So now when the server crashes or has
// to go down for some other reason, registered users will be able to load
// their inventory back when the server is up again.
//=============================================================================
class InvBank expands Mutator
	Config(InventoryBank);

struct Account
{
    var() config String userName, passWord;
};

struct UserInventory
{
    var() config String userName;
    var() config String userInventory; 
};

var() config bool bMayThrowWeaps;
var() config float minTimeBetweenLoads, minTimeBetweenSaves;
var() config String notSavedClasses[100];
var() config Account userAccounts[500];
var() config UserInventory userInventoryList[37500];

var int ammountOfUsers;

function String CreateAccount(String userName, String passWord, InventoryBank invBank)
{
	local int i;
	i = 0;
	
	if(invBank.Class != Class'InventoryBank.InventoryBank')
	{
		log("Someone tried to call CreateAccount() with something other then a 'InventoryBank'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	if(Len(passWord) < 5)
		return "Password must be longer then four characters";
	
	while(userAccounts[i].userName != "None" && userAccounts[i].userName != "")
	{
		if(userAccounts[i].userName == userName)
			return "Username already exists";
		i++;
	}
	
	userAccounts[i].userName = userName;
	userAccounts[i].passWord = passWord;
	SaveConfig();
	return "Account "$userName$" created successfully with password "$passWord;
}

function String SaveInventory(String userName, String passWord, Pawn InvOwner, InventoryBank invBank)
{
	local Inventory Inv;
	local int i, j;
	local bool temp;
	
	if(invBank.Class != Class'InventoryBank.InventoryBank')
	{
		log("Someone tried to call SaveInventory() with something other then a 'InventoryBank'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	temp = CheckPassword(userName, passWord);
	
	if(temp == false)
		return "Username or password incorrect";
	
	for(j = 0; j < 37500; j++)
	{
		if(userInventoryList[j].userName == userName)
			userInventoryList[j].userName = "";
	}
	
	foreach allactors( class'Inventory', Inv)
	{
		j = 0;
		temp = true;
	
		while(notSavedClasses[j] != "")
		{
			if(String(Inv.Class) == notSavedClasses[j])
				temp = false;
			j++;
		}
	
		if(!Inv.IsA('Ammo') && Inv.Owner == InvOwner && temp)
		{
			while(userInventoryList[i].userName != "")
				i++;
				
			userInventoryList[i].userName = userName;
			userInventoryList[i].userInventory = String(Inv.Class);
			log(userName$" "$userInventoryList[i].userInventory$" "$i);
		}
	}
	SaveConfig();
	
	return "Inventory saved";
}

/*function bool CheckForDublicateClass( Class classesList[400] , Inventory invToCheck)
{
	local int i;
	
	while(classesList[i] != None)
	{
		if(classesList[i] == invToCheck.Class)
		{
			log("Found dublicate class");
			return false;
		}
		i++;
	}
	return true;
}*/

function String LoadInventory(String userName, String passWord, Pawn InvOwner, InventoryBank invBank)
{
	local Class<Inventory> aInventoryClass;
	local Inventory aInventory;
	local Ammo ammo;
	local bool temp;
	local int j;
	
	if(invBank.Class != Class'InventoryBank.InventoryBank')
	{
		log("Someone tried to call LoadInventory() with something other then a 'InventoryBank'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	temp = CheckPassword(userName, passWord);
	
	if(temp == false)
		return "Username or password incorrect";
		
	for(j = 0; j < 37500; j++)
	{
		if(userInventoryList[j].userName == userName)
		{
			aInventoryClass = class<Inventory>( DynamicLoadObject(userInventoryList[j].userInventory, class'Class'));
			aInventory = InvOwner.Spawn(aInventoryClass);

			temp = InvOwner.Inventory.HandlePickupQuery(aInventory);
			if(temp == false && aInventory != None)
			{
				//aInventory.bHeldItem = true;
				//aInventory.GiveTo(InvOwner);
				if(aInventory.IsA('Weapon'))
					Weapon(aInventory).bCanThrow = bMayThrowWeaps;
				aInventory.bInstantRespawn = false;
				aInventory.RespawnTime = 0.0;
				aInventory.Touch(InvOwner);
			}
		}
	}
	return "Inventory loaded successfully";
}

function Bool CheckPassword(String userName, String passWord)
{
	local int i;
	i = 0;

	while(userAccounts[i].userName != "")
	{
		if(userAccounts[i].userName == userName)
		{		
			if(userAccounts[i].passWord == passWord)
			{
				log("password was correct");
				return true;
			}
			else
			{
				log("password was wrong");
				return false;
			}
		}
		i++;
	}
	
	return false;
}

defaultproperties
{
				minTimeBetweenLoads=20.000000
				minTimeBetweenSaves=20.000000
				notSavedClasses(0)="InventoryBank.InventoryBank"
				notSavedClasses(1)="UnrealShare.DispersionPistol"
				notSavedClasses(2)="UnrealShare.Translator"
				userAccounts(0)=(userName="aap",Password="koekjes")
				userInventoryList(0)=(userName="aap",UserInventory="UnrealI.Rifle")
				userInventoryList(1)=(userName="aap",UserInventory="UnrealShare.ShieldBelt")
				userInventoryList(2)=(userName="aap",UserInventory="UnrealI.FlakCannon")
				userInventoryList(3)=(userName="aap",UserInventory="UnrealShare.Eightball")
				userInventoryList(4)=(userName="aap",UserInventory="UnrealShare.AutoMag")
				userInventoryList(5)=(userName="aap",UserInventory="UnrealI.Minigun")
				userInventoryList(6)=(userName="aap",UserInventory="UnrealI.Razorjack")
				userInventoryList(7)=(userName="aap",UserInventory="UnrealShare.Armor")
				userInventoryList(8)=(UserInventory="UnrealShare.Armor")
}
